package ehpc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// InstallNFSClient invokes the ehpc.InstallNFSClient API synchronously
// api document: https://help.aliyun.com/api/ehpc/installnfsclient.html
func (client *Client) InstallNFSClient(request *InstallNFSClientRequest) (response *InstallNFSClientResponse, err error) {
	response = CreateInstallNFSClientResponse()
	err = client.DoAction(request, response)
	return
}

// InstallNFSClientWithChan invokes the ehpc.InstallNFSClient API asynchronously
// api document: https://help.aliyun.com/api/ehpc/installnfsclient.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) InstallNFSClientWithChan(request *InstallNFSClientRequest) (<-chan *InstallNFSClientResponse, <-chan error) {
	responseChan := make(chan *InstallNFSClientResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.InstallNFSClient(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// InstallNFSClientWithCallback invokes the ehpc.InstallNFSClient API asynchronously
// api document: https://help.aliyun.com/api/ehpc/installnfsclient.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) InstallNFSClientWithCallback(request *InstallNFSClientRequest, callback func(response *InstallNFSClientResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *InstallNFSClientResponse
		var err error
		defer close(result)
		response, err = client.InstallNFSClient(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// InstallNFSClientRequest is the request struct for api InstallNFSClient
type InstallNFSClientRequest struct {
	*requests.RpcRequest
	InstanceId string `position:"Query" name:"InstanceId"`
}

// InstallNFSClientResponse is the response struct for api InstallNFSClient
type InstallNFSClientResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	InvokeId  string `json:"InvokeId" xml:"InvokeId"`
}

// CreateInstallNFSClientRequest creates a request to invoke InstallNFSClient API
func CreateInstallNFSClientRequest() (request *InstallNFSClientRequest) {
	request = &InstallNFSClientRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("EHPC", "2018-04-12", "InstallNFSClient", "ehs", "openAPI")
	return
}

// CreateInstallNFSClientResponse creates a response to parse from InstallNFSClient response
func CreateInstallNFSClientResponse() (response *InstallNFSClientResponse) {
	response = &InstallNFSClientResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
